# Copyright 2018  Lars Wirzenius
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import ick2


N = 1000  # Max number of line to include in log


class NotificationAPI:
    def __init__(self, config):
        self._config = config

    def find_missing_route(self, missing_path):
        return [
            {
                "method": "POST",
                "path": "/notify",
                "callback": self.notify,
            },
        ]

    def notify(self, content_type, body, **kwargs):
        ick2.log.log("info", msg_text="Notification requested", kwargs=kwargs)

        recipients = body.get("recipients", [])
        build = body.get("build", {})
        log = body.get("log", "")
        log = "".join(f"{line}\n" for line in log.splitlines()[-N:])

        sendmail = ick2.Sendmail()
        sendmail.set_config(self._config)
        sendmail.send(recipients, build, log)

        return ick2.OK("")
